###################################################
### chunk number 1: a
###################################################
#line 199 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
require(xts)
data(sample_matrix)
class(sample_matrix)
str(sample_matrix)
matrix_xts <- as.xts(sample_matrix,dateFormat='Date')
str(matrix_xts)
df_xts <- as.xts(as.data.frame(sample_matrix),
 important='very important info!')
str(df_xts)


###################################################
### chunk number 2: xtsconstructor
###################################################
#line 225 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
xts(1:10, Sys.Date()+1:10)


###################################################
### chunk number 3: xtsmethods eval=FALSE
###################################################
## #line 280 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
## matrix_xts['2007-03']


###################################################
### chunk number 4: xtsmethods-hidden
###################################################
#line 283 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
head(matrix_xts['2007-03'],5)
cat('...\n')


###################################################
### chunk number 5: xtsmethods2 eval=FALSE
###################################################
## #line 290 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
## matrix_xts['::2007-01-07'] # or matrix_xts['/2007-01-07']


###################################################
### chunk number 6: xtsmethods2-hidden
###################################################
#line 293 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
matrix_xts['::2007-01-07']


###################################################
### chunk number 7: xtsfirstandlast eval=FALSE
###################################################
## #line 306 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
## first(matrix_xts,'1 week')


###################################################
### chunk number 8: xtsfirstandlast-hidden
###################################################
#line 309 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
head(first(matrix_xts,'1 week'))


###################################################
### chunk number 9: xtsfirstandlast2
###################################################
#line 315 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
first(last(matrix_xts,'1 week'),'3 days')


###################################################
### chunk number 10: indexClass
###################################################
#line 337 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
indexClass(matrix_xts)
indexClass(convertIndex(matrix_xts,'POSIXct'))


###################################################
### chunk number 11: xtsaxTicksByTime
###################################################
#line 358 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
axTicksByTime(matrix_xts, ticks.on='months')


###################################################
### chunk number 12: xtsplot
###################################################
#line 364 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
plot(matrix_xts[,1],major.ticks='months',minor.ticks=FALSE,main=NULL,col=3)


###################################################
### chunk number 13: asxtsreclass
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
# using xts-style subsetting doesn't work on non-xts objects
sample_matrix['2007-06']
# convert to xts to use time-based subsetting
str(as.xts(sample_matrix)['2007-06'])

# reclass to get to original class back
str(reclass(as.xts(sample_matrix)['2007-06']))


###################################################
### chunk number 14: usereclass
###################################################
#line 436 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
z <- zoo(1:10,Sys.Date()+1:10)
# filter converts to a ts object - and loses the zoo class
(zf <- filter(z, 0.2))
class(zf)
# using Reclass, the zoo class is preserved
(zf <- Reclass(filter(z, 0.2)))
class(zf)


###################################################
### chunk number 15: periodicity
###################################################
#line 466 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
periodicity(matrix_xts)


###################################################
### chunk number 16: endpoints
###################################################
#line 478 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
endpoints(matrix_xts,on='months')
endpoints(matrix_xts,on='weeks')


###################################################
### chunk number 17: toperiod
###################################################
#line 489 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
to.period(matrix_xts,'months')
periodicity(to.period(matrix_xts,'months'))

# changing the index to something more appropriate
to.monthly(matrix_xts)


###################################################
### chunk number 18: periodapply
###################################################
#line 516 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
# the general function, internally calls sapply
period.apply(matrix_xts[,4],INDEX=endpoints(matrix_xts),FUN=max)


###################################################
### chunk number 19: applymonthly
###################################################
#line 521 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
# same result as above, just a monthly interface
apply.monthly(matrix_xts[,4],FUN=max)


###################################################
### chunk number 20: periodsum
###################################################
#line 526 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
# using one of the optimized functions - about 4x faster
period.max(matrix_xts[,4], endpoints(matrix_xts))


###################################################
### chunk number 21: devtryxts
###################################################
#line 590 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
period.apply


###################################################
### chunk number 22: attributes
###################################################
#line 717 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
str(attributes(matrix_xts))
str(xtsAttributes(matrix_xts))

# attach some attributes
xtsAttributes(matrix_xts) <- list(myattr="my meta comment")
attr(matrix_xts, 'another.item') <- "one more thing..."

str(attributes(matrix_xts))
str(xtsAttributes(matrix_xts))


###################################################
### chunk number 23: subclass
###################################################
#line 741 "d:/Rcompile/CRANpkg/local/2.12/xts/inst/doc/xts.Rnw"
xtssubclass <- structure(matrix_xts, class=c('xts2','xts','zoo'))
class(xtssubclass)


